#include "GLOBAL.H"

// Register Functions
void pdelay(double delaytime);
int  mod(int,int);
void setReg(WORD,BYTE);
void checkReg(WORD,BYTE);
void setAddressRegs(WORD,WORD);
BYTE readReg(WORD);
void DisplayNICRegs(void);
void DisplayPciRegs();
void DisplayEEPROM();


// NIC Functions
int initNIC();
int resetNIC( unsigned long );
void stopNIC(void);
void startNIC(void);
int  NICLoopback(int);
int writeMacAddress( unsigned * );
int writeID( int, BYTE );
void EuphyterPhyReset();
void EuphyterPhyAdjust();
void CorrectPhyCoefficient();

int sendMgkPkt( BYTE * );
void setMedia( unsigned long mediaSpeed );

int pwrMgtMode( int );

void interrupt far mcPhyISR( );

void ReadMACAddress( UINT16 * );
void ReadEEWord( unsigned short, UINT32, UINT16* );
void WriteEEWord( unsigned short pMear, UINT32 wordOffset, UINT16 EeData );
int checkSumCheck(  );
// unsigned eeread( int offset );
void eeput( UINT32 value, int nbits );
UINT16 eeget( int nbits );
void writeEeEnable();
void writeEeDisable();
int doEeCheckSum();
int writeEeDefaults();
int readMacFile( unsigned char *inputString );
int writeMacFile(void);

// NIC Register Setup
void AddressInit(void);
void setDCR(int);
void setCURR(int);
void setBoundary(void);

// Helper Functions
void createPacket(void);
WORD getHeader(etherPacket_t *);
void displayPointers(void);
BYTE displayPacket( unsigned long,int);
BYTE sendPing(void);
BYTE receivePing(void);
void fillMem(WORD,WORD,WORD);
int  readMem(WORD,WORD,WORD);
void clearscreen( );

// Transfer Functions
void dummyTransfer(void);
int  MacSend(BYTE *,WORD);
int findNIC(bool bShowInfo);


extern int PciBiosFindDevice( unsigned, unsigned, unsigned, int *, int *, int * );
extern int PciBiosReadConfigWord( int, int, int, int, unsigned short * );
extern int PciBiosWriteConfigWord( int, int, int, int, int );
extern int PciBiosFindCardInt();
extern unsigned long DosLogicalToPhysical( void * );
extern unsigned long inpd( unsigned short );
extern unsigned outpd( unsigned short, unsigned long );
extern unsigned long DosGetTime( );
void delay( unsigned short );
void mdelay( unsigned );
void msleep( unsigned );