/*$no list*//*$no trace     <<< wgraphic.h >>> */
/*
 *
 * This file the types and functions related to graphics modes.
 *
 * Mix Software Inc.  Copyright (c) 1992
 *
**/

/*---------------------------------------------------------------
  --- SECTION 1 - Constants                                   ---
  ---------------------------------------------------------------*/
/*--- Graphics Info Codes ---*/
#define G_WIDTH       1
#define G_HEIGHT      2
#define G_VIEWHEIGHT  3
#define G_VIEWWIDTH   4
#define G_X           5
#define G_Y           6
#define G_VIEWX       7
#define G_VIEWY       8
#define G_OVERLAP     9

/*---------------------------------------------------------------
  --- SECTION 2 - Type Definitions                            ---
  ---------------------------------------------------------------*/

#ifndef  WINDOW_TYPEDEF
#define  WINDOW_TYPEDEF
typedef void *   Window;
#endif

#ifndef  GRAPHIC_TYPEDEF
#define  GRAPHIC_TYPEDEF
typedef void * Saved_Graphics;
#endif
#if defined(_MSC_VER) || (!defined(__BORLANDC__) && !defined(__TURBOC__) && !defined(__POWERC) && !defined(__TSC__) && !defined(__WATCOMC__))
#define g_free g_free_
#endif
/*---------------------------------------------------------------
  --- SECTION 3 - Function Declarations                       ---
  ---------------------------------------------------------------*/

#ifdef __cplusplus
extern "C" {
#endif
int            g_free(Saved_Graphics data);
int            g_info(Window wd, int id);
int            g_init(int graphics_mode);
int            g_overlap(Window wd, int x1, int y1, int x2, int y2);
int            g_restore(Saved_Graphics data);
int            g_restore_area(Window wd, Saved_Graphics data, int x, int y);
int            g_restore_screen(Saved_Graphics data, int x, int y);
int            g_restore_text(Saved_Graphics data, int col, int row);
Saved_Graphics g_save(Window wd);
Saved_Graphics g_save_all(Window wd);
Saved_Graphics g_save_area(Window wd, int x1, int y1, int x2, int y2);
Saved_Graphics g_save_screen(int x1, int y1, int x2, int y2);
Saved_Graphics g_save_text(int c1, int r1, int c2, int r2);
#ifdef __cplusplus
}
#endif
/*$list*//*$trace           <<< wgraphic.h >>> */
