;#define PciBiosFunctionId   0xb1
;#define pciBiosFindDevice   0x02
;#define PciBios16bitInt     0x1a
;#define PciBiosNscVendorId  0x100b
;#define pciBiosPresent 0x01
;#define PciCfgBaseAddr0 0x10
;#define PciCfgBaseAddr1 0x12
;#define PciBiosFunctionId 0xb1
;#define pciBiosWriteConfigWord 0x0c
;#define pciBiosReadCfgWord 0x09

name pcibios

;       .MODEL  small, c
.MODEL	large, c
.486

PciBiosFindDevice PROTO C vendorId:WORD, deviceId:WORD, index:WORD, pci_bus:NEAR PTR WORD, dev:NEAR PTR WORD, func:NEAR PTR WORD
PciBiosReadConfigWord  PROTO C bus:WORD, dev:WORD, func:WORD, regOffset:WORD, value:NEAR PTR WORD
PciBiosWriteConfigWord PROTO C bus:WORD, dev:WORD, func:WORD, regOffset:WORD, value:WORD
DosLogicalToPhysical   PROTO C LogicalAddress:NEAR PTR WORD
inpd PROTO C IO_Address:WORD
outpd PROTO C IO_Address:WORD, IO_Value:DWORD
DosGetTime PROTO C 

        .DATA
        .CODE

PciBiosFindDevice  PROC  C vendorId:WORD, deviceId:WORD, index:WORD, pci_bus:NEAR PTR WORD, dev:NEAR PTR WORD, func:NEAR PTR WORD

	push	es
	push	di
	push	si

        mov     dx, vendorId                ; VendorId
        mov     cx, deviceId                ; DeviceId
        mov     si, index                   ; Index
        mov     ah, 0b1h                    ;pciBiosFnId
        mov     al, 02h                     ;pciFindDevice

	int	1ah

	or	ah, ah                 	; error?
	jnz	pbfdError
;        les     di,  pci_bus       ; save bus number
        mov     di, pci_bus       ; save bus number;
	mov	al, bh
        mov     [di], ax

;        les     di, NEAR PTR dev       ; Dev
        mov     di, dev       ; Dev
	mov	al, bl
	shr	al, 3
        mov     [di], ax

;        les     di, NEAR PTR func       ; Func
        mov     di, func       ; Func
	mov	al, bl
	and	al,7
       mov     [di], ax
	xor 	ax, ax
	jmp	pbfdExit
pbfdError:
	mov	al, ah
	xor	ah, ah
pbfdExit:
	pop	si
	pop	di
	pop	es
	ret

PciBiosFindDevice  ENDP

;int PciBiosReadConfigWord(
;               int bus,                /* which bus */
;               int dev,                /* which device */
;               int func,               /* which function */
;               int regOffset,          /* which register to read */
;               unsigned short *value         /* result of read */
;       )
;{
;unsigned short valNum;

PciBiosReadConfigWord PROC C bus:WORD, dev:WORD, func:WORD, regOffset:WORD, value:NEAR PTR WORD

	push	si
	push	di

      mov   bx, dev
	shl	bl, 3
      mov   ax, func
	or	bl, al
      mov   ax, bus
	mov	bh, al
      mov   di, regOffset
      mov   ah, 0b1h                    ;PciBiosFunctionId

      mov   al, 09h                     ;pciBiosReadCfgWord
	int	1ah
	or	ah, ah
	jnz	pbrdwError

      mov   di, value
      mov   [di], cx

pbrdwError:
	mov	al, ah
	xor	ah, ah
	pop	di
	pop	si

      ret

PciBiosReadConfigWord ENDP

;       
;       int PciBiosWriteConfigWord( 
;               int bus,                /* which bus */
;               int dev,                /* which device */
;               int func,               /* which function */
;               int offset,             /* which register to write */
;               uint16 value            /* value to write */
;       )
;       
PciBiosWriteConfigWord PROC C bus:WORD, dev:WORD, func:WORD, regOffset:WORD, value:WORD

	push	si
	push	di

      mov   bx, dev
	shl	bl, 3
      mov   ax, func
	or	bl, al
      mov   ax, bus
	mov	bh, al
      mov   di, regOffset
      mov   ah, 0b1h          ; PciBiosFunctionId
	mov	al, 0ch		; pciBiosWriteConfigWord
	mov	cx, value

	int	1ah

	or	ah, ah
	jz	pbwrwExit
	mov	al, ah
	xor	ah, ah

pbwrwExit:
	pop	di
	pop	si
	ret

PciBiosWriteConfigWord ENDP

;unsigned long DosLogicalToPhysical( void *LogicalAddress )
;{
;union {
;        unsigned value[ 2 ];
;        unsigned long val;
;        } junk;
;
;_asm{

DosLogicalToPhysical  PROC  C LogicalAddress:NEAR PTR WORD

;        mov     dx, [bp+6]             ; segment portion
        mov     dx, LogicalAddress
        mov     dx, ds                  ; segment portion
	mov	ax, dx			; copy to ax
	shl	ax, 4			; * 16
	shr	dx, 12		
;        add     ax, [bp+4]                ; offset portion
        add     ax, LogicalAddress         ; offset portion
	adc	dx, 0

	ret				; return result in DX:AX

DosLogicalToPhysical    ENDP

inpd PROC  C IO_Address:WORD

        mov     dx, IO_Address
        in      eax, dx
        mov     edx, eax
        shr     edx, 16

        ret

inpd ENDP

outpd PROC  C IO_Address:WORD, IO_Value:DWORD

        mov eax, IO_Value
        mov dx, IO_Address
        out dx, eax
        ret

outpd ENDP

BIOS_TIMER	equ	46ch		; Tick Counter for system
MS_PER_TICK	equ	55

;
; 	uint32	DosGetTime( void )	return a tick count in ms in DS:AX
;					ODI has it's own, others can 
;					#define NsmGetTime to DosGetTime in
;					nsm.h
;
DosGetTime PROC C 

    	push	es
    	xor	ax, ax
    	mov	es, ax
    	mov	ax, es:[BIOS_TIMER]
    	mov	dx, MS_PER_TICK
    	mul	dx			; DX:AX = DX * AX
    	pop	es
		ret

DosGetTime ENDP


	END
